#include "aboutdialog.h"
#include "xpm/mark.h"

AboutDialog::AboutDialog(MineTimer *timer0){
  Gtk::TextIter iter;
  int i;

  timer=timer0;
  timeGrab=0;

  add_modal_grab();
  set_resizable(FALSE);
  set_position(Gtk::WIN_POS_CENTER);
  set_keep_above(true);

  timeGrab=timer->Stop();

  set_title("ABOUT");
  aboutIcon=Gdk::Pixbuf::create_from_xpm_data(question_xpm);
  set_icon(aboutIcon);
  
  vbox=get_vbox();

  tagTable=Gtk::TextTagTable::create();

  textBuffer=Gtk::TextBuffer::create(tagTable);

  i=0;
  iter=textBuffer->get_iter_at_offset(0);
  mark[0]=textBuffer->create_mark(iter);
  iter=textBuffer->insert(iter,"Schrdinger");
  mark[1]=textBuffer->create_mark(iter);
  iter=textBuffer->insert(iter,"=");
  mark[2]=textBuffer->create_mark(iter);
  iter=textBuffer->insert(iter,"MineSweeper");
  mark[3]=textBuffer->create_mark(iter);
  iter=textBuffer->insert(iter," -1.2");
  mark[4]=textBuffer->create_mark(iter);
  iter=textBuffer->insert(iter,"\n");
  mark[5]=textBuffer->create_mark(iter);
  iter=textBuffer->insert(iter,"\n");
  mark[6]=textBuffer->create_mark(iter);
  iter=textBuffer->insert(iter,"Created ");
  mark[7]=textBuffer->create_mark(iter);
  iter=textBuffer->insert(iter,"by ");
  mark[8]=textBuffer->create_mark(iter);
  iter=textBuffer->insert(iter,"yuichiro");
  mark[9]=textBuffer->create_mark(iter);
  iter=textBuffer->insert(iter," (2008)");
  mark[10]=textBuffer->create_mark(iter);

  //  textBuffer->apply_tag(mTag1,textBuffer->begin(),textBuffer->end());

  titleStr=Gtk::TextTag::create();
  titleStr->property_foreground()="blue";
  tagTable->add(titleStr);

  createStr=Gtk::TextTag::create();
  createStr->property_justification()=Gtk::JUSTIFY_RIGHT;
  tagTable->add(createStr);

  nameStr=Gtk::TextTag::create();
  nameStr->property_style()=Pango::STYLE_ITALIC;
  tagTable->add(nameStr);

  yearStr=Gtk::TextTag::create();
  yearStr->property_weight()=Pango::WEIGHT_BOLD;
  tagTable->add(yearStr);

  textBuffer->apply_tag(titleStr,
			textBuffer->get_iter_at_mark(mark[0]),
			textBuffer->get_iter_at_mark(mark[4]));
  textBuffer->apply_tag(createStr,
			textBuffer->get_iter_at_mark(mark[6]),
			textBuffer->get_iter_at_mark(mark[10]));
  textBuffer->apply_tag(nameStr,
			textBuffer->get_iter_at_mark(mark[8]),
			textBuffer->get_iter_at_mark(mark[9]));
  textBuffer->apply_tag(yearStr,
			textBuffer->get_iter_at_mark(mark[9]),
			textBuffer->get_iter_at_mark(mark[10]));

  textView =new Gtk::TextView(textBuffer);
  textView->set_size_request(250,-1);

  //  vbox->pack_start(*label,Gtk::PACK_EXPAND_WIDGET,0);
  vbox->pack_start(*textView,Gtk::PACK_EXPAND_WIDGET,0);

  textView->set_editable(false);
  textView->set_cursor_visible(false);

  textView->show();
  // label->show();
  vbox->show();

  okButton=add_button("Ok",Gtk::RESPONSE_OK);

  okButton->set_flags(Gtk::CAN_DEFAULT);
  okButton->set_flags(Gtk::HAS_DEFAULT);

  okButton->show();
  show_all();

  okButton->signal_clicked().connect
    (sigc::mem_fun(*this,&AboutDialog::OkClicked));
  signal_delete_event().connect
    (sigc::mem_fun(*this,&AboutDialog::DeleteEvent));
}

AboutDialog::~AboutDialog(){
  delete okButton;
  delete textView;
}

bool AboutDialog::DeleteEvent(GdkEventAny *event){
  std::cout<<"delete...\n";
  remove_modal_grab();
   if(timeGrab==0){
     timer->Start();
   }
  delete this;
  return 1;
}
void AboutDialog::OkClicked(){
  std::cout<<"Quit\n";
  remove_modal_grab();
   if(timeGrab==0){
     timer->Start();
   }
  delete this;
}
