#include "exit.h"
#include "xpm/bomb.h"

ExitDialog::ExitDialog(MineTimer *timer0){
  timeGrab=0;

  timer=timer0;
  timeGrab=timer->Stop();

  dialog=new Gtk::Dialog();
  
  dialog->set_title("EXIT");
  exitIcon=Gdk::Pixbuf::create_from_xpm_data(bomb_xpm);
  dialog->set_icon(exitIcon);
  dialog->set_position(Gtk::WIN_POS_CENTER);

  vbox=dialog->get_vbox();
  
  label= new Gtk::Label("Quit ?",false);

  vbox->pack_start(*label,Gtk::PACK_EXPAND_WIDGET,0);

  label->show();
  vbox->show();

  okButton=dialog->add_button("OK",Gtk::RESPONSE_OK);
  cancelButton=dialog->add_button("Cancel",Gtk::RESPONSE_CANCEL);
  
  okButton->signal_clicked().connect
    (sigc::mem_fun(*this,&ExitDialog::OkClicked));
  cancelButton->signal_clicked().connect
    (sigc::mem_fun(*this,&ExitDialog::CancelClicked));
  dialog->signal_delete_event().connect
    (sigc::mem_fun(*this,&ExitDialog::SignalDelete));
  
  dialog->show();
  dialog->add_modal_grab();
  dialog->set_resizable(FALSE);
  dialog->set_keep_above(true);
}

ExitDialog::~ExitDialog(){
  delete okButton;
  delete cancelButton;
  delete label;
  delete dialog;
}

bool ExitDialog::SignalDelete(GdkEventAny *event){
  std::cout<<"delete...\n";
   dialog->remove_modal_grab();
   if(timeGrab==0){
     timer->Start();
   }
  delete this;
  return 1;
}
void ExitDialog::OkClicked(){
  std::cout<<"Quit\n";
   dialog->remove_modal_grab();
  exit(0);
}
void ExitDialog::CancelClicked(){
  std::cout<<"Return...\n";
   dialog->remove_modal_grab();
   if(timeGrab==0){
     timer->Start();
   }
  delete this;
}
