#include "menu.h"

MineMenu::MineMenu(){
  menubar=new Gtk::MenuBar();
  fileMenu=new Gtk::Menu();
  fileItem=new Gtk::MenuItem("Game");
  resetItem=new Gtk::MenuItem("Reset");
  beginnerItem =new Gtk::MenuItem("Beginner");
  mediumItem =new Gtk::MenuItem("Medium");
  advanceItem =new Gtk::MenuItem("Advance");
  setgridItem=new Gtk::MenuItem("Set Grid");
  exitItem=new Gtk::MenuItem("Exit");
  fileSep1=new Gtk::SeparatorMenuItem();
  fileSep2=new Gtk::SeparatorMenuItem();
  optionMenu=new Gtk::Menu();
  optionItem=new Gtk::MenuItem("Option");
  scoreItem=new Gtk::MenuItem("Score");
  saveItem=new Gtk::MenuItem("Save");
  loadItem=new Gtk::MenuItem("Load");
  helpMenu= new Gtk::Menu();
  helpItem= new Gtk::MenuItem("Help");
  aboutItem= new Gtk::MenuItem("About");
}

MineMenu::~MineMenu(){
  delete menubar;
  delete fileMenu;
  delete fileItem;
  delete resetItem;
  delete beginnerItem;
  delete mediumItem;
  delete advanceItem;
  delete setgridItem;
  delete exitItem;
  delete fileSep1;
  delete fileSep2;
  delete optionMenu;
  delete optionItem;
  delete scoreItem;
  delete saveItem;
  delete loadItem;
  delete helpMenu;
  delete helpItem;
  delete aboutItem;
}

void MineMenu::ActivateExit(){
  ExitDialog *exitDialog;
  exitDialog=new ExitDialog(timer);
}
void MineMenu::ActivateReset(){
  std::cout<<"Reset..."<<std::endl;
  table->ReCreate(table->nRow,table->nCol,table->pBomb,table->nSize);
  status->Refresh();
}
void MineMenu::ActivateBeginner(){
  std::cout<<"Beginner..."<<std::endl;
  table->ReCreate(10,10,10,24);
  status->Refresh();
}
void MineMenu::ActivateMedium(){
  std::cout<<"Medium..."<<std::endl;
  table->ReCreate(15,15,15,14);
  status->Refresh();
}
void MineMenu::ActivateAdvance(){
  std::cout<<"Advance..."<<std::endl;
  table->ReCreate(20,20,20,9);
  status->Refresh();
}

void MineMenu::ActivateSetGrid(){
  gridDialog->Show();
}
void MineMenu::ActivateScore(){
  ScoreDialog *scoreDialog;

  scoreFile->ViewList();
  std::cout<<"ACTIVATE SCORE"<<std::endl;

  scoreDialog = new ScoreDialog(scoreFile,timer);
  scoreDialog->Create(0);
}
void MineMenu::ActivateSave(){
  std::cout<<"ACTIVATE SAVE"<<std::endl;
  if(table->startFlag!=0){
    SaveDialog *saveDialog;  
    saveDialog = new SaveDialog(table,saveFile,timer);
  }
  /*
  saveFile->SaveState(table);
  if(saveFile->FindState()){
    std::cout<<"WRONG SAVE.data"<<std::endl;
  }
  */
}
void MineMenu::ActivateLoad(){
  int i;
  std::cout<<"ACTIVATE LOAD"<<std::endl;
  if(saveFile->FindState()){
   std::cout<<"WRONG SAVE.data"<<std::endl;
  }
  else{
    i=0;
    while(i<table->nCol*table->nRow){
      delete table->board[i];
      table->board[i]=NULL;
      i++;
    }
    saveFile->LoadState(table);
  }
}
void MineMenu::ActivateAbout(){
  AboutDialog *aboutDialog;
  std::cout<<"ACTIVATE ABOUT"<<std::endl;
  
  aboutDialog= new AboutDialog(timer);
}

Gtk::MenuBar *MineMenu::Create(MineTable *table0,MineStatus *status0,
			       MineTimer *timer0,ScoreFile *scoreFile0,
			       SaveFile *saveFile0){
  table=table0;
  status=status0;
  timer=timer0;
  scoreFile=scoreFile0;
  saveFile=saveFile0;

  fileMenu->append(*resetItem);
  resetItem->show();
  
  fileMenu->append(*fileSep1);
  fileSep1->show();
    
  fileMenu->append(*beginnerItem);
  beginnerItem->show();

  fileMenu->append(*mediumItem);
  mediumItem->show();

  fileMenu->append(*advanceItem);
  advanceItem->show();
  
  fileMenu->append(*fileSep2);
  fileSep2->show();

  fileMenu->append(*exitItem);
  exitItem->show();
  
  fileItem->set_submenu(*fileMenu);
  menubar->append(*fileItem);
  fileItem->show();
  fileMenu->show();

  optionMenu->append(*setgridItem);
  setgridItem->show();

  optionMenu->append(*scoreItem);
  scoreItem->show();
  
  optionMenu->append(*saveItem);
  saveItem->show();
  /*
  optionMenu->append(*loadItem);
  loadItem->show();
  */
  optionItem->set_submenu(*optionMenu);
  menubar->append(*optionItem);
  optionItem->show();
  optionMenu->show();

  helpMenu->append(*aboutItem);
  aboutItem->show();

  helpItem->set_submenu(*helpMenu);
  menubar->append(*helpItem);
  helpItem->show();
  helpMenu->show();

  menubar->show();
  
  gridDialog= new GridDialog();
  gridDialog->Create(table,status); 
  
  exitItem->signal_activate().connect
    (sigc::mem_fun(*this,&MineMenu::ActivateExit));
  resetItem->signal_activate().connect
    (sigc::mem_fun(*this,&MineMenu::ActivateReset));
  beginnerItem->signal_activate().connect
    (sigc::mem_fun(*this,&MineMenu::ActivateBeginner));
  mediumItem->signal_activate().connect
    (sigc::mem_fun(*this,&MineMenu::ActivateMedium));
  advanceItem->signal_activate().connect
    (sigc::mem_fun(*this,&MineMenu::ActivateAdvance));
  
  setgridItem->signal_activate().connect
    (sigc::mem_fun(*this,&MineMenu::ActivateSetGrid));
  scoreItem->signal_activate().connect
    (sigc::mem_fun(*this,&MineMenu::ActivateScore));
  saveItem->signal_activate().connect
    (sigc::mem_fun(*this,&MineMenu::ActivateSave));
  aboutItem->signal_activate().connect
    (sigc::mem_fun(*this,&MineMenu::ActivateAbout));

  return menubar;
}
