#ifndef SCORE_DIALOG_H
#define SCORE_DIALOG_H

#include <gtkmm.h>
#include <gtkmm/treeview.h>
#include <iostream>

#include "timer.h"
#include "scorefile.h"

class ScoreCol : public Gtk::TreeModel::ColumnRecord{
 public:
  ScoreCol(){
    add(num);
    add(score); 
    add(board);
    add(strBoard);
    add(bomb); 
    add(sec);
    add(strSec);
    add(rate);
    add(strMode);
    add(strName);
  }
  Gtk::TreeModelColumn<int> num;
  Gtk::TreeModelColumn<int> score;
  Gtk::TreeModelColumn<int> board;
  Gtk::TreeModelColumn<Glib::ustring> strBoard;
  Gtk::TreeModelColumn<int> bomb;
  Gtk::TreeModelColumn<int> sec;
  Gtk::TreeModelColumn<Glib::ustring> strSec;
  Gtk::TreeModelColumn<int> rate;
  Gtk::TreeModelColumn<Glib::ustring> strMode;
  Gtk::TreeModelColumn<Glib::ustring> strName;
};

class ScoreDialog : public Gtk::Dialog {
  typedef Gtk::TreeModel::Children type_children;
 private:
  Glib::RefPtr<Gdk::Pixbuf> scoreIcon;
  Gtk::CheckButton *beginnerCheck;
  Gtk::CheckButton *mediumCheck;
  Gtk::CheckButton *advanceCheck;
  Gtk::CheckButton *freeCheck;
  Gtk::Table *checkBox;
 public:
  int targetRow;
  int beginnerFlag;
  int mediumFlag;
  int advanceFlag;
  int freeFlag;
  int timeGrab;
  MineTimer *timer;
  ScoreFile *scoreFile;
  Gtk::ScrolledWindow *scrWin;
  Gtk::TreeView *listView;
  Glib::RefPtr<Gtk::ListStore> mList;
  Gtk::CellRendererProgress *cellProg;
  Gtk::TreeViewColumn *progCol;
  ScoreCol *scoreCol;
  Gtk::Button *okButton;
  Gtk::VBox *vbox;
  ScoreDialog(ScoreFile *scoreFile0,MineTimer *timer0);
  ~ScoreDialog();
  void SelectMode(char *buffer,int mode);
  void Create(int targetRow0);
  void SetNum();
  void ReadFile();
 protected:
  void OkClicked();
  bool SignalDelete(GdkEventAny *event);
  void BeginnerChecked();
  void MediumChecked();
  void AdvanceChecked();
  void FreeChecked();
};

#endif
