#include "scorefile.h"

ScoreFile::ScoreFile(){
  listCount=0;
  firstList=NULL;
  endList=NULL;
}

ScoreFile::~ScoreFile(){
}

int ScoreFile::CalcScore(int nRow0,int nCol0,int nBomb0,int nSec0){
  int score0;
  int board0;
  int tmp1,tmp2;
  double tmp3;

  board0=nRow0*nCol0;
  tmp1=nSec0/30+10;
  tmp2=nBomb0*10000/board0;
  tmp3=pow(nBomb0,1);
  score0=(int)tmp3*tmp2/tmp1;  

  std::cout<<"SCORE:"<<score0<<" SEC/30:"<<tmp1<<
    " RATE:"<<tmp2<<" BOMB^3/2:"<<tmp3<<std::endl;

  return score0;
}

int ScoreFile::CalcName(const char *NAME,int length){
  int i,same;

  same=0;
  i=0;
  while(i<length){
    same+=(int)*(NAME+i);
    //    std::cout<<*(NAME+i)<<":"<<(int)*(NAME+i)<<"\t";
    i++;
  }
  //  std::cout<<"SAME : "<<same<<std::endl;

  return same;
}

int ScoreFile::WriteFile(int nRow0,int nCol0,int nBomb0,
			  int nSec0,int mode0,Glib::ustring &name){
  std::ofstream FO;
  int score0,nameValue;
  time_t times;

  nameValue=ScoreFile::CalcName(name.c_str(),name.size());
  score0=ScoreFile::CalcScore(nRow0,nCol0,nBomb0,nSec0);  
  
  time(&times);
  FO.open("MINE_SCORE.data",std::ios::out|std::ios::app);
  FO<<score0<<"\t";
  FO<<nRow0<<"\t";
  FO<<nCol0<<"\t";
  FO<<nBomb0<<"\t";
  FO<<nSec0<<"\t";
  FO<<mode0<<"\t";
  FO<<times<<"\t";
  FO<<nRow0*nCol0+nBomb0+nSec0+nameValue<<"\t";
  FO<<name<<std::endl;
  FO.close();

  return times;
}

void ScoreFile::AppendList(ScoreItem *node){
  if(endList==NULL){
    firstList=node;
    endList=node;
    node->prev=NULL;
    node->next=NULL;
  }
  else{
    node->next=NULL;
    node->prev=endList;
    endList->next=node;
    endList=node;
  }
  listCount++;
}
void ScoreFile::PrependList(ScoreItem *node){
  if(firstList==NULL){
    firstList=node;
    endList=node;
    node->prev=NULL;
    node->next=NULL;
  }
  else{
    node->next=firstList;
    node->prev=NULL;
    firstList->prev=node;
    firstList=node;
  }
  listCount++;
}

void ScoreFile::InsertList(ScoreItem *node,ScoreItem *target){
  if(target->prev==NULL){
    node->next=target;
    node->prev=NULL;
    target->prev=node;
    firstList=node;
  }
  else{
    node->next=target;
    node->prev=target->prev;
    (target->prev)->next=node;
    target->prev=node;
  }
  listCount++;
}

void ScoreFile::RejectList(ScoreItem *node){
  if(node->next==NULL){
      if(node->prev==NULL){
	firstList=NULL;
	endList=NULL;
      }
      else{
	(node->prev)->next=NULL;
	endList=node->prev;
      }
  }
  else{
    if(node->prev==NULL){
      (node->next)->prev=NULL;
      firstList=node->next;
    }
    else{
      (node->next)->prev=node->prev;
      (node->prev)->next=node->next;
    }
  }
  listCount--;
}

void ScoreFile::ALLDeleteList(){
  ScoreItem *node;
  ScoreItem *tmp;

  node=firstList;
  while(node){
    tmp=node->next;
    ScoreFile::RejectList(node);
    delete node;
    node=NULL;
    node=tmp;
  }
  if(listCount==0){
    std::cout<<"SCORE ALL DELETE!"<<std::endl;  
  }
  else{
    std::cout<<"SCORE ERROR NO ALL DELETE"<<std::endl;
  }
}

void ScoreFile::ViewList(){
  ScoreItem *node;
  ScoreItem *tmp;
  int i=0;

  node=firstList;
  while(node){
    tmp=node->next;
    std::cout<<"["<<i<<"] : ";
    std::cout<<node->score<<"\t";
    std::cout<<node->row<<"\t";
    std::cout<<node->col<<"\t";
    std::cout<<node->bomb<<"\t";
    std::cout<<node->sec<<"\t";
    std::cout<<node->mode<<"\t";
    std::cout<<node->TIME<<"\t";
    std::cout<<node->name<<std::endl;
    i++;
    node=tmp;
  }
  if(listCount==i){
    std::cout<<"OK! MATCH LIST"<<std::endl;  
  }
  else{
    std::cout<<"NO MATCH LIST"<<std::endl;
  }
}

void ScoreFile::SortList(){
  ScoreItem *iNode;
  ScoreItem *jNode;
  ScoreItem *iTmp;
  ScoreItem *jTmp;
  
  iNode=firstList;
  while(iNode){
    iTmp=iNode->next;
    jNode=firstList;
    while(iNode!=jNode){
      jTmp=jNode->next;
      if(iNode->score>jNode->score){
	ScoreFile::RejectList(iNode);
	ScoreFile::InsertList(iNode,jNode);
	break;
      }
      else if(iNode->score==jNode->score){
	if(iNode->sec<jNode->sec){
	  ScoreFile::RejectList(iNode);
	  ScoreFile::InsertList(iNode,jNode);
	  break;
	}
      }
      jNode=jTmp;
    }
    iNode=iTmp;
  }
}

void ScoreFile::AddSortList(int nRow0,int nCol0,int nBomb0,
			int nSec0,int mode0,int select0){
  ScoreItem *node;
  ScoreItem *add;
  ScoreItem *tmp;
  int flag=0;

  int score0;

  score0=ScoreFile::CalcScore(nRow0,nCol0,nBomb0,nSec0);

  add= new ScoreItem;

  add->score=score0;
  add->row=nRow0;
  add->col=nCol0;
  add->bomb=nBomb0;
  add->sec=nSec0;
  add->mode=mode0;
  add->select=select0;

  node=firstList;
  while(node){
    tmp=node->next;
    if(score0>node->score){
      ScoreFile::InsertList(add,node);
      flag=1;
      break;
    }
    else if(nSec0==node->score){
      if(nSec0<node->sec){
	ScoreFile::InsertList(add,node);
	flag=1;
	break;
      }
    }
    node=tmp;
  }
  if(flag==0){
    ScoreFile::AppendList(add);
  }
}

void ScoreFile::EnterScore(Glib::ustring *READ,int length){
  ScoreItem *node;
  int row,col,bomb,sec,ID1,ID2,nameValue;
  if(length==9){
    ID1=atoi((READ+7)->c_str());
    row=atoi((READ+1)->c_str());
    col=atoi((READ+2)->c_str());
    bomb=atoi((READ+3)->c_str());
    sec=atoi((READ+4)->c_str());
    nameValue=ScoreFile::CalcName((READ+8)->c_str(),(READ+8)->size());
    ID2=row*col+bomb+sec+nameValue;
    if(ID1==ID2){
      node = new ScoreItem;
      node->score=atoi((READ)->c_str());
      node->row=row;
      node->col=col;
      node->bomb=bomb;
      node->sec=sec;
      node->mode=atoi((READ+5)->c_str());
      node->TIME=atoi((READ+6)->c_str());
      node->name=*(READ+8);
      node->select=0;
      ScoreFile::AppendList(node);
    }
    else{
      std::cout<<"WRONG SCORE VALUE_8"<<std::endl;
    }
  }
  else{
    std::cout<<"WRONG SCORE ELEMENT"<<std::endl;
  }
}

void ScoreFile::ReadFile(){
  std::ifstream FI;
  char ch;
  char str[255];
  char *s0;
  Glib::ustring READ[10];
  Glib::ustring *RP;
  int strCount=0;
  int tabCount=0;
  int enterCount=0;
  
  RP=&READ[0];
  s0=&str[0];

  FI.open("MINE_SCORE.data",std::ios::in);
  if(!(FI)){
    std::cout<<"CAN'T OPEN MINE_SCORE.data"<<std::endl;
  }
  else{
    std::cout<<"OPEN MINE_SCORE.data"<<std::endl;
    while(FI.get(ch)){
      
      if(ch=='\t'){
	*(s0+strCount)='\0';
	*(RP+tabCount)=s0;

	tabCount++;
	strCount=0;
      }
      else if(ch=='\n'){
	*(s0+strCount)='\0';
	*(RP+tabCount)=s0;
	//	*(RP+tabCount+1)='\0';
	/*
	  int i;
	std::cout<<"["<<enterCount<<"] : ";
	i=0;
	while(i<tabCount+1){
	  std::cout<<*(RP+i)<<"\t";
	  i++;
	}
	std::cout<<std::endl;
	*/
	ScoreFile::EnterScore(RP,tabCount+1);
	enterCount++;
	tabCount=0;
	strCount=0;
      }
      else{
	*(s0+strCount)=ch;
	strCount++;
      }
    }
    std::cout<<"NUM :"<<enterCount<<std::endl;
    FI.close();
  }
}
