#ifndef SCOREFILE_H
#define SCOREFILE_H

#include <gtkmm.h>
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cmath>
#include <ctime>

class ScoreItem{
 public:
  int score;
  int row;
  int col;
  int bomb;
  int sec;
  int mode;
  int select;
  int TIME;
  Glib::ustring name;
  ScoreItem *next;
  ScoreItem *prev;
};

class ScoreFile{
 public:
  ScoreItem *firstList;
  ScoreItem *endList;
  int listCount;
  ScoreFile();
  ~ScoreFile();
  int CalcScore(int Row0,int nCol0,int nBomb0,int nSec0);
  int CalcName(const char *NAME,int length);
  int WriteFile(int nRow0,int nCol0,int nBomb0,
		int nSec0,int mode0,Glib::ustring &text);
  void ReadFile();
  void AppendList(ScoreItem *node);
  void PrependList(ScoreItem *node);
  void InsertList(ScoreItem *node,ScoreItem *target);
  void RejectList(ScoreItem *node);
  void ALLDeleteList();
  void ViewList();
  void SortList();
  
  void AddSortList(int nRow0,int nCol0,int nBomb0,
		   int nSec0,int mode0,int select0);
  void EnterScore(Glib::ustring *READ,int length);
};

#endif
