#include "setgrid.h"
#include "xpm/mark.h"

GridDialog::GridDialog(){
  dialog=new Gtk::Dialog();
  hbox=new Gtk::HBox(FALSE,0);
  rowAdj=new Gtk::Adjustment(10,8,100,1,10,0);
  colAdj=new Gtk::Adjustment(10,8,100,1,10,0);
  bombAdj=new Gtk::Adjustment(10,5,60,1,10,0);
  sizeAdj=new Gtk::Adjustment(24,4,100,1,10,0);
  rowSpin=new Gtk::SpinButton(*rowAdj,0,0);
  colSpin=new Gtk::SpinButton(*colAdj,0,0);
  bombSpin=new Gtk::SpinButton(*bombAdj,0,0);
  sizeSpin=new Gtk::SpinButton(*sizeAdj,0,0);
  hLabel1=new Gtk::Label("x",FALSE);
  hLabel2=new Gtk::Label("bomb:",FALSE);
  hLabel3=new Gtk::Label("% size:",FALSE);
  //  hLabel3=new Gtk::Label("%",FALSE);
  vbox=dialog->get_vbox();
  reset=dialog->add_button("Reset",Gtk::RESPONSE_NONE);
  close=dialog->add_button("Close",Gtk::RESPONSE_NONE);

  dialog->set_title("SET GRID");
  gridIcon=Gdk::Pixbuf::create_from_xpm_data(flag_xpm);
  dialog->set_icon(gridIcon);
  dialog->set_position(Gtk::WIN_POS_CENTER);
  dialog->set_keep_above(true);
}

GridDialog::~GridDialog(){
  delete close;
  delete reset;
  delete rowSpin;
  delete colSpin;
  delete bombSpin;
  delete sizeSpin;
  delete rowAdj;
  delete colAdj;
  delete bombAdj;
  delete sizeAdj;
  delete hLabel1;
  delete hLabel2;
  delete hLabel3;
  delete dialog;
}

void GridDialog::CloseClicked(){
  std::cout<<"Return..."<<std::endl;
  dialog->hide();
}
void GridDialog::ResetClicked(){
  std::cout<<"Reset..."<<std::endl;
  table->ReCreate(tRow,tCol,tBomb,tSize);
  status->Refresh();
}
bool GridDialog::DeleteSignal(GdkEventAny *event){
  std::cout<<"delete..."<<std::endl;
  dialog->hide();
  return 1;
}
void GridDialog::RowChange(){
  tRow=(int)rowSpin->get_value();
}
void GridDialog::ColChange(){
  int range;
  tCol=(int)colSpin->get_value();
  range=(300/tCol)-6;
  if(range<8){
    range=8;
  }
  tSize=range;
  sizeSpin->set_value(range);
}
void GridDialog::BombChange(){
  tBomb=(int)bombSpin->get_value();
}
void GridDialog::SizeChange(){
  tSize=(int)sizeSpin->get_value();
}

void GridDialog::Create(MineTable *table0,MineStatus *status0){
  table=table0;
  status=status0;
  tRow=table->nRow;
  tCol=table->nCol;
  tBomb=table->pBomb;
  tSize=table->nSize;

  rowSpin->set_value(tRow);
  rowSpin->set_numeric(FALSE);
  colSpin->set_value(tCol);
  colSpin->set_numeric(FALSE);
  bombSpin->set_value(tBomb);
  bombSpin->set_numeric(FALSE);
  sizeSpin->set_value(tSize);
  sizeSpin->set_numeric(FALSE);

  vbox->pack_start(*hbox,Gtk::PACK_EXPAND_WIDGET,0);
  hbox->pack_start(*rowSpin,Gtk::PACK_SHRINK,0);
  hbox->pack_start(*hLabel1,Gtk::PACK_EXPAND_WIDGET,0);
  hbox->pack_start(*colSpin,Gtk::PACK_SHRINK,0);
  hbox->pack_start(*hLabel2,Gtk::PACK_EXPAND_WIDGET,0);
  hbox->pack_start(*bombSpin,Gtk::PACK_SHRINK,0);
  hbox->pack_start(*hLabel3,Gtk::PACK_EXPAND_WIDGET,0);
  hbox->pack_start(*sizeSpin,Gtk::PACK_SHRINK,0);
  vbox->show();
  hbox->show();
  rowSpin->show();
  colSpin->show();
  hLabel1->show();
  hLabel2->show();
  hLabel3->show();
  bombSpin->show();
  sizeSpin->show();
  
  rowSpin->signal_value_changed().connect
    (sigc::mem_fun(*this,&GridDialog::RowChange));
  colSpin->signal_value_changed().connect
    (sigc::mem_fun(*this,&GridDialog::ColChange));
  bombSpin->signal_value_changed().connect
    (sigc::mem_fun(*this,&GridDialog::BombChange));
  sizeSpin->signal_value_changed().connect
    (sigc::mem_fun(*this,&GridDialog::SizeChange));

  close->signal_clicked().connect
    (sigc::mem_fun(*this,&GridDialog::CloseClicked));
  reset->signal_clicked().connect
    (sigc::mem_fun(*this,&GridDialog::ResetClicked));
  dialog->signal_delete_event().connect
    (sigc::mem_fun(*this,&GridDialog::DeleteSignal));

  dialog->set_resizable(FALSE);
}

void GridDialog::Show(){
  rowSpin->set_value(table->nRow);
  colSpin->set_value(table->nCol);
  bombSpin->set_value(table->pBomb);
  sizeSpin->set_value(table->nSize);
  dialog->show();
}
