#include "table.h"

MineTable::MineTable(MineWindow *window0,MineTimer *timer0,
		     ScoreFile *scoreFile0){
  window=window0;
  nRow=10;
  nCol=10;
  pBomb=10;
  nSize=24;
  sizeFlag=1;
  startFlag=0;
  table = new Gtk::Table(nRow,nCol,FALSE);
  table->set_homogeneous(false);
  scrWin= new Gtk::ScrolledWindow();
  scrWin->set_policy(Gtk::POLICY_AUTOMATIC,Gtk::POLICY_AUTOMATIC);
  scrWin->add(*table);
  scrWin->show();
  image = new MineImage();
  image->SetScale(5,5);
  timer = timer0;
  scoreFile=scoreFile0;

  table->signal_size_request().connect
    (sigc::mem_fun(*this,&MineTable::SizeAllocateEvent));
}

void MineTable::SizeAllocateEvent(GtkRequisition *req){
  GdkGeometry ghints;
  int width,height,baseW,baseH;
    width=req->width;
    height=req->height;
    
    
    
  if(sizeFlag==1){

    std::cout<<"width="<<width<<",height="<<height<<std::endl;
    std::cout<<"CHANGE"<<std::endl;
    
    sizeFlag=0;
    baseW=width+20;
    baseH=height+105;
    ghints.min_width=100;
    ghints.min_height=100;
    ghints.max_width=baseW+8;
    ghints.max_height=baseH+8;
    ghints.base_width=baseW;
    ghints.base_height=baseH;
    ghints.width_inc=1;
    ghints.height_inc=1;
    ghints.min_aspect=1;
    ghints.max_aspect=1;
    
    if(baseW>800){
      baseW=800;
    }
    if(baseH>600){
      baseH=600;
    }

    window->set_geometry_hints(*window,ghints,Gdk::HINT_MAX_SIZE);
    window->resize(baseW,baseH);
    
  }
}

MineTable::~MineTable(){
  int i=0;

  delete image;
  delete scrWin;

  delete table;

  while(i<nCol*nRow){
    delete board[i];
    board[i]=NULL;
    i++;
  }
}



void MineTable::SetMode(){
  std::cout<<nRow<<"\t"<<nCol<<"\t"<<pBomb<<std::endl;
  if(nCol==10&&nRow==10&&pBomb==10){
    mode=1;
  }
  else if(nCol==15&&nRow==15&&pBomb==15){
    mode=2;
  }
  else if(nCol==20&&nRow==20&&pBomb==20){
    mode=3;
  }
  else{
    mode=4;
  }
}
/*
void MineTable::SetSize(){
  int range;
  range=(300/nCol)-6;
  if(range<8){
    range=8;
  }
  image->SetScale(range,range);
}
*/
int MineTable::SetBomb(int i,int j,int num,int times){

  int bombFlag,randam;
  bombFlag=0;
  
  srand((num+1)*(i+1)*(j+1));
  randam=rand()*(times+1)*(num+1);
  bombFlag+=(abs(randam)%1000<pBomb*10);

  return bombFlag;
}

void MineTable::SetNum(){
 int i,j,k,l,count,tmp;
 
 i=0;
 j=0;
  while(i<nCol){
    while(j<nRow){
      count=0;
      for(k=MAX(i-1,0);k<=MIN(i+1,nCol-1);k++){
	for(l=MAX(j-1,0);l<=MIN(j+1,nRow-1);l++){
	  tmp=k*nRow+l;
	  if(board[tmp]->bomb==1){
	    count++;
	  }
	}
      }
      tmp=i*nRow+j;
      //     std::cout<<"count\t"<<tmp<<"\t"<<count<<std::endl;
      board[tmp]->num=count;
      j++;
    }
    j=0;
    i++;
  }
}

void MineTable::GameOver(){
  int i=0;
  char name[255];
  char *n0;
  n0=&name[0];

  startFlag=0;
  timer->Stop();
  while(i<nCol*nRow){
    if(board[i]->state==2){
      if(board[i]->bomb){
	board[i]->SetImage(image->CreateMark(4));
      }
      else{
	board[i]->SetImage(image->CreateMark(5));
      }
    }
    else{
      if(board[i]->bomb){
	board[i]->SetImage(image->CreateBomb());
      }
    }
    board[i]->set_sensitive(false);
    board[i]->state=0;
    i++;
  }
  if(BombCount==nBomb){
    if(MissCount==0){
 

      std::cout<<"CLEAR!"<<std::endl;
      
      NameDialog *nameDialog;
      nameDialog= new NameDialog(this);
    }
  }
  //  mode=0;
}

void MineTable::DecreaseBomb(int Num0){
  board[Num0]->num--;
}

void MineTable::DecreaseAround(int Num0){
  if(board[Num0]->bomb==1){
    //  std::cout<<"BOMB :"<<Num0<<std::endl;
    BlankButton(&MineTable::DecreaseBomb,Num0);
    board[Num0]->bomb=0;
    nBomb--;
  }
}

void MineTable::AroundZERO(int Num0){
  BlankButton(&MineTable::DecreaseAround,Num0);
}

void MineTable::ButtonHit(int Num0){
  //  void (MineTable::*func)(int)=&MineTable::ButtonHit;
  MineButton *button;
  button=board[Num0];
  
  if(button->state!=0){

    if(button->bomb){
      // button->SetImage(image->CreateBomb());
    }
    else{
      if(button->state==2){
	MissCount--;
      }
      button->state=0;
      button->set_active(true);
      button->set_sensitive(false);
      button->SetImage(image->CreateNumber(button->num));
      if(button->num==0){
	BlankButton(&MineTable::ButtonHit,Num0);
	// std::cout<<"Num0 :"<<Num0<<" num=0"<<std::endl;
      }
    }
  }
  else{
    //    std::cout<<"Num0 :"<<Num0<<" STATE=0"<<std::endl;
  }
}

void MineTable::BlankERROR(void (MineTable::*func)(int),int Num0){
    std::cout<<"BLANK_ERROR"<<std::endl;
}
void MineTable::BlankUpLeft(void (MineTable::*func)(int),int Num0){
  //  std::cout<<"BLANK_UpLeft"<<std::endl;
  (this->*func)(Num0);
  (this->*func)(Num0+1);
  (this->*func)(Num0+nRow);
  (this->*func)(Num0+nRow+1);
}
void MineTable::BlankUp(void (MineTable::*func)(int),int Num0){
  //  std::cout<<"BLANK_Up"<<std::endl;
  (this->*func)(Num0);
  (this->*func)(Num0-1);
  (this->*func)(Num0+1);
  (this->*func)(Num0+nRow-1);
  (this->*func)(Num0+nRow);
  (this->*func)(Num0+nRow+1);
}
void MineTable::BlankUpRight(void (MineTable::*func)(int),int Num0){
  //  std::cout<<"BLANK_UpRight"<<std::endl;
  (this->*func)(Num0);
  (this->*func)(Num0-1);
  (this->*func)(Num0+nRow-1);
  (this->*func)(Num0+nRow);
}
void MineTable::BlankRight(void (MineTable::*func)(int),int Num0){
  (this->*func)(Num0);
  (this->*func)(Num0-nRow);
  (this->*func)(Num0-nRow-1);
  (this->*func)(Num0-1);
  (this->*func)(Num0+nRow-1);
  (this->*func)(Num0+nRow);
}
void MineTable::BlankDownRight(void (MineTable::*func)(int),int Num0){
  (this->*func)(Num0);
  (this->*func)(Num0-nRow);
  (this->*func)(Num0-nRow-1);
  (this->*func)(Num0-1);
}
void MineTable::BlankDown(void (MineTable::*func)(int),int Num0){
  (this->*func)(Num0);
  (this->*func)(Num0-nRow-1);
  (this->*func)(Num0-1);
  (this->*func)(Num0-nRow);
  (this->*func)(Num0+1);
  (this->*func)(Num0-nRow+1);
}
void MineTable::BlankDownLeft(void (MineTable::*func)(int),int Num0){
  (this->*func)(Num0);
  (this->*func)(Num0-nRow);
  (this->*func)(Num0+1);
  (this->*func)(Num0-nRow+1);
}
void MineTable::BlankLeft(void (MineTable::*func)(int),int Num0){
  (this->*func)(Num0);
  (this->*func)(Num0-nRow);
  (this->*func)(Num0-nRow+1);
  (this->*func)(Num0+1);
  (this->*func)(Num0+nRow+1);
  (this->*func)(Num0+nRow);
}
void MineTable::BlankALL(void (MineTable::*func)(int),int Num0){
  //  std::cout<<"BLANK_ALL"<<std::endl;
  (this->*func)(Num0);
  (this->*func)(Num0-1);
  (this->*func)(Num0+1);
  (this->*func)(Num0-nRow);
  (this->*func)(Num0+nRow);
  (this->*func)(Num0-nRow-1);
  (this->*func)(Num0+nRow-1);
  (this->*func)(Num0-nRow+1);
  (this->*func)(Num0+nRow+1);
}


void (MineTable::*BLANK_BUTTON[20])
  (void (MineTable::*func)(int),int Num0)={
  &MineTable::BlankALL, // 0
  &MineTable::BlankUp,
  &MineTable::BlankLeft,
  &MineTable::BlankUpLeft,
  &MineTable::BlankDown,  // 4
  &MineTable::BlankERROR, 
  &MineTable::BlankDownLeft,
  &MineTable::BlankERROR,
  &MineTable::BlankRight, // 8
  &MineTable::BlankUpRight,
  &MineTable::BlankERROR, 
  &MineTable::BlankERROR,
  &MineTable::BlankDownRight, // 12
  &MineTable::BlankERROR,
  &MineTable::BlankERROR, 
  &MineTable::BlankERROR, // 15
};

void MineTable::BlankButton(void (MineTable::*func)(int),int Num0){
  int flag=0;
  //  void (MineTable::*func)(int)=&MineTable::ButtonHit;

  MineButton *button;
  button=board[Num0];
  flag=(flag+(button->row>nRow-2))<<1;
  flag=(flag+(button->col>nCol-2))<<1;
  flag=(flag+(button->row<1))<<1;
  flag=(flag+(button->col<1));
  //  std::cout<<"["<<flag<<"]"<<std::endl;
  (this->*BLANK_BUTTON[flag])(func,Num0);
}

bool MineTable::PressEvent(GdkEventButton *event,int Num0){
  MineButton *button;
  button=board[Num0];

  //  std::cout<<"PRESS"<<std::endl;
  if(startFlag==1){
    if(event->button==1){
      //      std::cout<<"1PRESS"<<std::endl;
    }
    else if(event->button==2){
      //     std::cout<<"2PRESS"<<std::endl;
    }
    else if(event->button==3){
      //     std::cout<<"3PRESS"<<std::endl;
      if(button->state){
	if(button->state==2){
	  if(button->bomb){
	    BombCount--;
	  }
	  else{
	    MissCount--;
	  }
	}
	button->state++;
	if(button->state>2)
	  button->state=1;
	if(button->state==2){
	  if(button->bomb){
	    BombCount++;
	  }
	  else{
	    MissCount++;
	  }
	}
	button->SetImage(image->CreateMark(button->state));
      }
    }
    if(BombCount==nBomb){
      if(MissCount==0){
	GameOver();
      }
    }
  }
  return true;
}

bool MineTable::ReleaseEvent(GdkEventButton *event,int Num0){
  //  std::cout<<"RELEASE EVENT :"<<Num0<<std::endl;
  //  void (MineTable::*func)(int)=&MineTable::ButtonHit;
  MineButton *button;

  if(startFlag==0&&event->button==1){
    /*
    timer->Start();
    startFlag=1;
    */
    MineTable::CreateValue(Num0);
    //   std::cout<<" CREATE VALUE"<<std::endl;
  }
  button=board[Num0];
  if(startFlag==1){
    if(event->button==1){
      //    std::cout<<"1RELEASE"<<std::endl;
      if(button->state==2){
	//   button->set_active(false);
      }
      else{
	button->state=0;
	button->set_active(true);
	button->set_sensitive(false);
	
	if(button->bomb){
	  button->SetImage(image->CreateBomb());
	  MineTable::GameOver();
	}
	else{
	  button->SetImage(image->CreateNumber(button->num));
	  if(button->num==0){
	    
	       BlankButton(&MineTable::ButtonHit,Num0);
	  }
	}
      }
    }
    else if(event->button==2){
      //    std::cout<<"2RELEASE"<<std::endl;
    }
    else if(event->button==3){
      //    std::cout<<"3RELEASE"<<std::endl;
    }
    if(BombCount==nBomb){
      if(MissCount==0){
	GameOver();
      }
    }
  }
  return true;
}

void MineTable::CreateValue(int Num0){
  time_t times;
  int i,j,k,l;
  int bombType=0,num1,num2;
  //  MineButton *button;
  
  int numBOARD[10000]={0};

  i=0;
  j=0;
  nBomb=0;
  timer->nSec=0;

  BombCount=0;
  MissCount=0;

  time(&times);

  while(i<nCol){
    while(j<nRow){
      num1=i*nRow+j;
      
      bombType=SetBomb(i,j,num1,(int)times);
      
      if(bombType==1){
	for(k=MAX(i-1,0);k<=MIN(i+1,nCol-1);k++){
	  for(l=MAX(j-1,0);l<=MIN(j+1,nRow-1);l++){
	    num2=k*nRow+l;
	    if(numBOARD[num2]<0){
	      board[num2]->num+=1;
	    }
	    else{
	      numBOARD[num2]+=1;
	    }
	  }
	}
	nBomb++;
      }

      board[num1]->bomb=bombType;

      board[num1]->num=numBOARD[num1];
      numBOARD[num1]=-1;
      j++;
    }
    j=0;
    i++;
  }

  // AroundZERO(Num0);
  BlankButton(&MineTable::DecreaseAround,Num0);

  timer->Start();
  startFlag=1;
}

void MineTable::CreateTable(){
  int i,j;
  int num;
  MineButton *button;

  // std::cout<<"CREATE BOARD"<<std::endl;

  timer->Stop();

  timer->timeLabel->set_label("time :");

  image->SetScale(nSize,nSize);
  MineTable::SetMode();

  i=0;
  j=0;
  while(i<nCol){
    while(j<nRow){
      num=i*nRow+j;
      
      button = new MineButton(j,i,0,1,0);
      button->SetImage((image->CreateMark(1)));
      //    std::cout<<"BOARD :"<<num<<std::endl;
      board[num]=button;
      table->attach(*button,j,j+1,i,i+1,
		    Gtk::SHRINK,Gtk::SHRINK,0,0);
      button->show();
      board[num]->signal_button_release_event().connect
	(sigc::bind(sigc::mem_fun(*this,&MineTable::ReleaseEvent),
		    num),false);
      board[num]->signal_button_press_event().connect
	(sigc::bind(sigc::mem_fun(*this,&MineTable::PressEvent),
		    num),false);
      j++;
    }
    j=0;
    i++;
  }

  startFlag=0;

  table->show();
}

void MineTable::KeepCreate(){

  int i,j,num;
  MineButton *button;

  timer->Stop();

  timer->timeLabel->set_label("time :");

  MineTable::SetMode();

  i=0;
  j=0;
  while(j<nCol){
    while(i<nRow){
      num=j*nRow+i;

      button=board[num];
      button->col=j;
      button->row=i;
      button->bomb=0;
      button->state=1;
      button->num=0;
      button->set_sensitive(true);
      button->set_active(false);
      button->SetImage(image->CreateMark(1));

      i++;
    }
    i=0;
    j++;
  }

  startFlag=0;
}

void MineTable::ReCreate(int nRow0,int nCol0,int pBomb0,int nSize0){
  int i=0;

  if((nRow==nRow0&&nCol==nCol0)&&nSize==nSize0){
    sizeFlag=0;
    pBomb=pBomb0;
    MineTable::KeepCreate();
  }
  else{

    while(i<nCol*nRow){
      /*
      std::cout<<"DELETE["<<i<<"]";
      */
      delete board[i];
       board[i]=NULL;
       /*
      std::cout<<"DELETE END"<<std::endl;
       */
      i++;
    }

    pBomb=pBomb0;
    nRow=nRow0;
    nCol=nCol0;
    nSize=nSize0;
    sizeFlag=1;
    table->resize(nRow,nCol);
    MineTable::CreateTable();
  }

}

Gtk::ScrolledWindow *MineTable::Show(){

  return scrWin;
}
