#ifndef TABLE_H
#define TABLE_H

#include <gtkmm.h>
#include <gtkmm/table.h>
#include <iostream>
#include <ctime>
#include <cstdlib>
#include "window.h"
#include "minebutton.h"
#include "timer.h"
#include "scorefile.h"
#include "scoredialog.h"
#include "xpm/image.h"
#include "namedialog.h"

#define MAX_H 100;
#define MAX_V 100;

class MineButton;

class MineStatus;

class GridDialog;

class MineWindow;

class MineTable {
 public:
  Gtk::ScrolledWindow *scrWin;
  MineWindow *window;
  ScoreFile *scoreFile;
  Gtk::Table *table;
  MineImage *image;
  MineButton *board[10000];
  MineTimer *timer;
  int sizeFlag;
  int startFlag;
  int nRow;
  int nCol;
  int nSize;
  int pBomb;
  int nBomb;
  int BombCount;
  int MissCount;
  int mode;
  MineTable(MineWindow *window0,MineTimer *timer0,
	    ScoreFile *scorefile0);
  ~MineTable();
  //  void SetSize();
  void SetMode();
  void SetNum();
  int SetBomb(int i,int j,int num,int times);
  void GameOver();
  void DecreaseAround(int Num0);
  void DecreaseBomb(int Num0);
  void AroundZERO(int Num0);
  void ButtonHit(int Num0);
  void BlankERROR(void (MineTable::*func)(int),int Num0);
  void BlankUpLeft(void (MineTable::*func)(int),int Num0);
  void BlankLeft(void (MineTable::*func)(int),int Num0);
  void BlankDownLeft(void (MineTable::*func)(int),int Num0);
  void BlankDown(void (MineTable::*func)(int),int Num0);
  void BlankDownRight(void (MineTable::*func)(int),int Num0);
  void BlankRight(void (MineTable::*func)(int),int Num0);
  void BlankUpRight(void (MineTable::*func)(int),int Num0);
  void BlankUp(void (MineTable::*func)(int),int Num0);
  void BlankALL(void (MineTable::*func)(int),int Num0);
  void BlankButton(void (MineTable::*func)(int),int Num0);
  void CreateValue(int Num0);
  void CreateTable();
  void KeepCreate();
  void ReCreate(int nRow0,int nCol0,int pBomb0,int nSize0);
  Gtk::ScrolledWindow *Show();
  bool ReleaseEvent(GdkEventButton *event,int Num0);
  bool PressEvent(GdkEventButton *event,int Num0);
  void SizeAllocateEvent(GtkRequisition *req);
};

#endif
