#ifndef MENU_H
#define MENU_H

#include <gtkmm.h>
#include <gtkmm/menubar.h>
#include <iostream>
#include "exit.h"
#include "setgrid.h"
#include "status.h"
#include "table.h"
#include "timer.h"
#include "scorefile.h"
#include "scoredialog.h"
#include "savefile.h"
#include "savedialog.h"
#include "aboutdialog.h"

class MineTable;

class SaveFile;

class GridDialog;

class MineMenu{
 private:
  Gtk::MenuBar *menubar;
  Gtk::Menu *fileMenu;
  Gtk::Menu *optionMenu;
  Gtk::Menu *helpMenu;
  Gtk::MenuItem *fileItem;
  Gtk::MenuItem *resetItem;
  Gtk::MenuItem *setgridItem;
  Gtk::MenuItem *exitItem;
  Gtk::MenuItem *optionItem;
  Gtk::MenuItem *scoreItem;
  Gtk::MenuItem *saveItem;
  Gtk::MenuItem *loadItem;
  Gtk::MenuItem *beginnerItem;
  Gtk::MenuItem *mediumItem;
  Gtk::MenuItem *advanceItem;
  Gtk::MenuItem *helpItem;
  Gtk::MenuItem *aboutItem;
  Gtk::SeparatorMenuItem *fileSep1;
  Gtk::SeparatorMenuItem *fileSep2;
  MineTimer *timer;
  MineTable *table;
  MineStatus *status;
  ScoreFile *scoreFile;
  SaveFile *saveFile;
  GridDialog *gridDialog;
 public:
  MineMenu();
  ~MineMenu();
  Gtk::MenuBar *Create(MineTable *table0,MineStatus *status0,
		       MineTimer *timer0,ScoreFile *scoreFile0,
		       SaveFile *saveFile0);
 protected:
  void ActivateExit();
  void ActivateReset();
  void ActivateBeginner();
  void ActivateMedium();
  void ActivateAdvance();
  void ActivateSetGrid();
  void ActivateScore();
  void ActivateSave();
  void ActivateLoad();
  void ActivateAbout();
};

#endif
