#include"namedialog.h"
#include"xpm/bomb.h"
#include <cctype>

void NameEntry::on_delete_text(int start_pos,int end_pos){
  Glib::ustring text;
  const char *ch;
  text=get_chars(start_pos,end_pos);
  std::cout<<"on delete :"<<text;
  std::cout<<":"<<start_pos<<"~"<<end_pos<<std::endl;
  ch=text.c_str();
  if(isupper(*ch)){
    length-=1;
  }
  else if(islower(*ch)){
    length-=2;    
  }
  else if(isdigit(*ch)){
    length-=1;
  }
  else{
    std::cout<<"ERROR ENTRY"<<std::endl;
  }
  text=get_text();
  std::cout<<"before:"<<text<<std::endl;
  text.erase(start_pos,1);
  std::cout<<"after :"<<text<<std::endl;
  //  set_text(text);
}

NameDialog::NameDialog(MineTable *table0){
  table=table0;
  timer=table->timer;
  scoreFile=table->scoreFile;

  Glib::ustring strings;

  add_modal_grab();
  set_title("NAME");
  nameIcon=Gdk::Pixbuf::create_from_xpm_data(bomb_xpm);
  set_icon(nameIcon);
  set_position(Gtk::WIN_POS_CENTER);

  vbox=get_vbox();
  hbox= new Gtk::HBox(false,0);
  label= new Gtk::Label("Name : ",false);
  entry= new Gtk::Entry();
  okButton=add_button("Ok",Gtk::RESPONSE_OK);
  hbox->pack_start(*label,Gtk::PACK_EXPAND_WIDGET,0);
  hbox->pack_start(*entry,Gtk::PACK_EXPAND_WIDGET,0);
  vbox->pack_start(*hbox,Gtk::PACK_EXPAND_WIDGET,0);

  //  entry->set_alignment(Gtk::ALIGN_RIGHT);
  //  label->set_size_request(80,-1);
  entry->set_width_chars(10);
  entry->set_max_length(8);

  set_resizable(false);
  set_keep_above(true);


  entry->signal_insert_text().connect
    (sigc::mem_fun(*this,&NameDialog::InsertText));
  /*
  entry->signal_delete_text().connect
    (sigc::mem_fun(*this,&NameDialog::DeleteText));
  */
  okButton->signal_clicked().connect
    (sigc::mem_fun(*this,&NameDialog::OkClicked));
  
  signal_delete_event().connect
    (sigc::mem_fun(*this,&NameDialog::DeleteEvent));

  okButton->set_flags(Gtk::CAN_DEFAULT);
  okButton->set_flags(Gtk::HAS_DEFAULT);

  set_default(*okButton);

  label->show();
  entry->show();
  okButton->show();
  hbox->show();
  vbox->show();
  show();
}

NameDialog::~NameDialog(){
  delete label;
  delete okButton;
  delete entry;
  delete hbox;
  
}

void NameDialog::InsertText(const Glib::ustring &text,int *position){
  int tSize;
  const char *ch;
  tSize=text.size();
  /*
  std::cout<<text<<"["<<tSize<<"]";
  std::cout<<*position-1<<"~"<<*position<<std::endl;
  */
  ch=text.c_str();
  
  if(islower(*(ch))){
    
  }
  else if(isdigit(*(ch))){
    
  }
  else{
    entry->delete_text(*position-tSize,*position);
  }
  /*
    if(!isalpha(*ch)&&!isdigit(*ch))
  */
}

void NameDialog::DeleteText(int start,int end){
  std::cout<<entry->get_chars(start,end)
	   <<":"<<start<<"~"<<end<<std::endl;
}

void NameDialog::OkClicked(){
  Glib::ustring text;
  int times;
  std::cout<<"Ok..."<<std::endl;
  remove_modal_grab();

  text=entry->get_text();
  std::cout<<"["<<text<<"]"<<std::endl;
  if(text.size()==0){
    std::cout<<"SIZE_ZERO"<<std::endl;  
  }
  times=scoreFile->WriteFile(table->nRow,table->nCol,table->nBomb,
		       timer->nSec,table->mode,text);
  
  scoreFile->ALLDeleteList();
  scoreFile->ReadFile();
  scoreFile->SortList();
  scoreFile->ViewList();
  
  ScoreDialog *scoreDialog;
  scoreDialog = new ScoreDialog(scoreFile,timer);
  scoreDialog->Create(times);
  
  delete this;
}
bool NameDialog::DeleteEvent(GdkEventAny *event){
  std::cout<<"no delete"<<std::endl;

  return 1;
}


