#ifndef NAME_DIALOG_H
#define NAME_DIALOG_H

#include<iostream>
#include<gtkmm.h>

#include "table.h"
#include "timer.h"
#include "scorefile.h"
#include "scoredialog.h"

class MineTable;

class NameEntry :public Gtk::Entry{
 public:
  int length;
  NameEntry(){
    length=0;
  };
 protected:
  virtual void on_delete_text(int start_pos,int end_pos);
};

class NameDialog : public Gtk::Dialog{
 private:
  Glib::RefPtr<Gdk::Pixbuf> nameIcon;
  MineTable *table;
  MineTimer *timer;
  ScoreFile *scoreFile;
  Gtk::Label *label;
  Gtk::Entry *entry;
  Gtk::Button *okButton;
  Gtk::VBox *vbox;
  Gtk::HBox *hbox;
  char buffer[255];
  int length;
 public:
  NameDialog(MineTable *table0);
  ~NameDialog();

 protected:
  void InsertText(const Glib::ustring &text,int *position);
  void DeleteText(int start,int end);
  void OkClicked();
  bool DeleteEvent(GdkEventAny *event);
};

#endif
