#include"savedialog.h"
#include "xpm/mark.h"

SaveDialog::SaveDialog(MineTable *table0,SaveFile *saveFile0,
		       MineTimer *timer0){
  timeGrab=0;

  timer=timer0;
  saveFile=saveFile0;
  table=table0;

  timeGrab=timer->Stop();

  okButton=add_button("Ok",Gtk::RESPONSE_OK);
  cancelButton=add_button("Cancel",Gtk::RESPONSE_CANCEL);
  
  okButton->show();
  cancelButton->show();

  vbox=get_vbox();

  label = new Gtk::Label("Save & Exit ?",false);

  vbox->pack_start(*label,Gtk::PACK_EXPAND_WIDGET,0);

    label->show();
    vbox->show();

  okButton->signal_clicked().connect
    (sigc::mem_fun(*this,&SaveDialog::OkClicked));
  cancelButton->signal_clicked().connect
    (sigc::mem_fun(*this,&SaveDialog::CancelClicked));
  signal_delete_event().connect
    (sigc::mem_fun(*this,&SaveDialog::SignalDelete));

  show();

  set_title("SAVE");
  saveIcon=Gdk::Pixbuf::create_from_xpm_data(flag_xpm);
  set_icon(saveIcon);
  set_position(Gtk::WIN_POS_CENTER_ALWAYS);

  add_modal_grab();
  set_resizable(FALSE);
  set_keep_above(true);
}

SaveDialog::~SaveDialog(){
  delete okButton;
  delete cancelButton;
  delete label;
}

bool SaveDialog::SignalDelete(GdkEventAny *event){
  std::cout<<"delete...\n";
   remove_modal_grab();
   if(timeGrab==0){
     timer->Start();
   }
  delete this;
  return 1;
}
void SaveDialog::OkClicked(){
  std::cout<<"Quit\n";
  saveFile->SaveState(table);
  if(saveFile->FindState()!=0){
    std::cout<<"SAVE FALSED"<<std::endl;
  }
  else{
    exit(0);
  }
  remove_modal_grab();
  if(timeGrab==0){
    timer->Start();
  }
  delete this;
}
void SaveDialog::CancelClicked(){
  std::cout<<"Return...\n";
   remove_modal_grab();
   if(timeGrab==0){
     timer->Start();
   }
  delete this;
}
