#include "savefile.h"
#include <sys/types.h>
#include <sys/stat.h>

SaveFile::SaveFile(){
}

SaveFile::~SaveFile(){
}

int SaveFile::ElementCheck(int flag0,int inode,int atime,int mtime,
			   int ctime){
  struct stat STATE;
  if(stat("MINE_SAVE.data",&STATE)==-1){
    std::cout<<"CAN'T GET MINE_SAVE.data"<<std::endl;
    flag0=1;
  }
  else{
    if(inode==(int)STATE.st_ino){
      std::cout<<"MATCH INODE"<<std::endl;
    }
    else{
      std::cout<<"INODE : "<<inode<<"!="<<STATE.st_ino<<std::endl;
      flag0=2;
    }
    if(atime==STATE.st_atime){
      std::cout<<"MATCH ATIME"<<std::endl;
    }
    else{
      std::cout<<"ATIME : "<<atime<<"!="<<STATE.st_atime<<std::endl;
    }
    if(ctime==STATE.st_ctime){
      std::cout<<"MATCH CTIME"<<std::endl;
    }
    else{
      std::cout<<"CTIME : "<<ctime<<"!="<<STATE.st_ctime<<std::endl;
      flag0=2;
    }
    if(mtime==STATE.st_mtime){
      std::cout<<"MATCH MTIME"<<std::endl;
    }
    else{
      std::cout<<"MTIME : "<<mtime<<"!="<<STATE.st_mtime<<std::endl;
      flag0=3;
    }
  }
  return flag0;
}

void SaveFile::SaveState(MineTable *table0){
  std::ofstream FO;
  int i=0;
  struct stat STATE;

  if(table0->mode>0){
    std::cout<<"WRITE"<<std::endl;
    std::cout<<(table0->timer)->nSec<<std::endl;
    std::cout<<(table0->board[0])->state<<std::endl;
    FO.open("MINE_SAVE.data",std::ios::out);
    /*
    FO<<"nRow nCol pBomb nBomb nSize ";
    FO<<"BombC MissC nSec mode"<<std::endl;
    */
    FO<<"STATE<"<<std::endl;
    FO<<table0->nRow<<"\t";
    FO<<table0->nCol<<"\t";
    FO<<table0->pBomb<<"\t";
    FO<<table0->nBomb<<"\t";
    FO<<table0->nSize<<"\t";
    FO<<table0->BombCount<<"\t";
    FO<<table0->MissCount<<"\t";
    FO<<(table0->timer)->nSec<<"\t";
    FO<<table0->mode<<std::endl;
    FO<<">"<<std::endl;
    /*
    FO<<"row col state bomb num"<<std::endl;
    */
    FO<<"BOARD<"<<std::endl;
    
    while(i<(table0->nCol * table0->nRow)){
      FO<<(table0->board[i])->row<<"\t";
      FO<<(table0->board[i])->col<<"\t";
      FO<<(table0->board[i])->state<<"\t";
      FO<<(table0->board[i])->bomb<<"\t";
      FO<<(table0->board[i])->num<<std::endl;
      i++;
    }
    FO<<">"<<std::endl;
    if(stat("MINE_SAVE.data",&STATE)==-1){
      std::cout<<"CAN'T GET MINE_SAVE.data"<<std::endl;
    }
    else{
      /*
      FO<<"inode st_atime st_mtime st_ctime"<<std::endl;
      */
      FO<<"FILE<"<<std::endl;
      
      FO<<STATE.st_ino<<"\t";
      FO<<STATE.st_atime<<"\t";
      FO<<STATE.st_mtime<<"\t";
      FO<<STATE.st_ctime<<std::endl;
      FO<<">"<<std::endl;
    }
    FO.close();
    //    exit(0);
  }
}
void SaveFile::EnterStatus(MineTable *table0,int *SP,
			   int length,int enterCount){
  if(length==9){
    /*
      int i=0;
    std::cout<<"ENTER STATUS"<<std::endl;
    std::cout<<"STATUS "<<enterCount<<" : ";
    while(i<length){
      std::cout<<*(SP+i)<<"\t";
      i++;
    }
    std::cout<<std::endl;
    */
    table0->nRow=*(SP+0);
    table0->nCol=*(SP+1);
    table0->pBomb=*(SP+2);
    table0->nBomb=*(SP+3);
    table0->nSize=*(SP+4);
    table0->BombCount=*(SP+5);
    table0->MissCount=*(SP+6);
    (table0->timer)->nSec=*(SP+7);
    table0->mode=*(SP+8);
  }
  else{
    std::cout<<"WRONG STATUS"<<std::endl;
  }
}
void SaveFile::EnterBoard(MineTable *table0,int *SP,
			  int length,int enterCount){
  MineButton *button;
  int tmp;
  if(length==5){
    tmp=*(SP+0)+*(SP+1)*(table0->nRow);
    if(tmp==enterCount-1){
      /*
	int i=0;
      std::cout<<"ENTER BOARD"<<std::endl;
      std::cout<<"BOARD "<<enterCount<<" : ";
      while(i<length){
	std::cout<<*(SP+i)<<"\t";
	i++;
      }
      std::cout<<std::endl;
      */
      button = new MineButton(*(SP+0),*(SP+1),*(SP+3),*(SP+2),*(SP+4));
      if(button->state==0){
	button->set_active(true);
	button->set_sensitive(false);
	if(button->bomb){
	  (button)->SetImage((table0->image)->CreateBomb());
	}
	else{
	  (button)->SetImage((table0->image)->CreateNumber(button->num));
	}
      }
      else{
	button->SetImage((table0->image)->CreateMark(button->state));
      }
      table0->board[tmp]=button;
      (table0->table)->attach(*button,
			      button->row,button->row+1,
			      button->col,button->col+1,
			      Gtk::SHRINK,
			      Gtk::SHRINK,0,0);
      button->show();
      (table0->board[tmp])->
	signal_button_release_event().connect
	(sigc::bind(sigc::mem_fun(*table0,&MineTable::ReleaseEvent),
		    tmp),false);
      (table0->board[tmp])->
	signal_button_press_event().connect
	(sigc::bind(sigc::mem_fun(*table0,&MineTable::PressEvent),
		    tmp),false);
    }
    else{
      std::cout<<"WRONG BOARD PLACE"<<std::endl;
    }
  }
  else{
    std::cout<<"WRONG BOARD ELEMENTS"<<std::endl;
  }
}
void SaveFile::EnterFile(MineTable *table0,int *SP,
			 int length,int enterCount){
  int inode,ctime,mtime,atime,flag0=0;
  if(length==4){
    inode=*(SP+0);
    atime=*(SP+1);
    mtime=*(SP+2);
    ctime=*(SP+3);

    flag0=SaveFile::ElementCheck(flag0,inode,atime,mtime,ctime);

    if(flag0==0){
      std::cout<<"OK FILE ELEMENT"<<std::endl;
    }
    else{
      std::cout<<"NO FILE ELEMENT"<<std::endl;
    }
  }
  else{
    std::cout<<"WORNG FILE ELEMENTS"<<std::endl;
  }
}

void (SaveFile::*ENTER_STATE[10])(MineTable *table0,int *SP,
				  int length,int enterCount)={
  &SaveFile::EnterStatus,
  &SaveFile::EnterBoard,
  &SaveFile::EnterFile,
};

void SaveFile::LoadState(MineTable *table0){
  std::ifstream FI;
  char ch;
  char str[255];
  char *s0;
  int tmp;
  int strCount=0;
  int tabCount=0;
  int enterCount=0;
  int actCount=0;
  int actFlag=0;
  int SAVE[10];
  int *SP;

  s0=&str[0];
  SP=&SAVE[0];

  std::cout<<"LOAD STATE"<<std::endl;

  FI.open("MINE_SAVE.data",std::ios::in);
  if(!(FI)){
    std::cout<<"NO MINE_SAVE.data"<<std::endl;
  }
  else{
    std::cout<<"OPEN MINE_SAVE.data"<<std::endl;
    while(FI.get(ch)){
      if(ch=='<'){
	actFlag=1;
      }
      if(ch=='>'){

	if(actFlag==1){
	  if(actCount==0){
	    (table0->table)->resize(table0->nRow,table0->nCol);
	    (table0->image)->SetScale(table0->nSize,table0->nSize);
	  }
	  actFlag=0;
	  actCount++;
	  strCount=0;
	  tabCount=0;
	  enterCount=0;
	}
	else{
	  std::cout<<"ERROR string > "<<std::endl;
	}
      }
      else{
	if(actFlag==1){
	  if(ch=='\t'){
	    *(s0+strCount)='\0';
	    tmp=atoi(s0);
	    *(SP+tabCount)=tmp;
	    strCount=0;
	    tabCount++;
	  }
	  else if(ch=='\n'){
	    if(enterCount>0){
	      *(s0+strCount)='\0';
	      tmp=atoi(s0);
	      *(SP+tabCount)=tmp;
	      tabCount++;
	      (this->*ENTER_STATE[actCount])(table0,SP,
					     tabCount,enterCount);
	    }
	    strCount=0;
	    tabCount=0;
	    enterCount++;
	  } 
	  else{
	    *(s0+strCount)=ch;
	    strCount++;
	  }
	}
      }
    }
    FI.close();
    remove("MINE_SAVE.data");
  }
  //  table0->SetSize();
  (table0->table)->show();
  
  table0->startFlag=1;
  (table0->timer)->Start();
}

int SaveFile::FindState(){
  std::ifstream FI;
  char ch;
  char str[255];
  char *s0;
  int tmp,sTmp,bTmp;
  int strCount=0;
  int tabCount=0;
  int enterCount=0;
  int actCount=0;
  int actFlag=0;
  int SAVE[10];
  int *SP;

  int flag0=0,matchFlag=0,missFlag=0,bFlag=0;
  int nRow0,nCol0,nBomb0,BombCount0,MissCount0,mode0;
  int inode,atime,mtime,ctime;
  s0=&str[0];
  SP=&SAVE[0];

  std::cout<<"LOAD STATE"<<std::endl;

  FI.open("MINE_SAVE.data",std::ios::in);
  if(!FI){
    std::cout<<"NO MINE_SAVE.data"<<std::endl;
    flag0=1;
  }
  else{
    std::cout<<"FIND:OPEN MINE_SAVE.data"<<std::endl;
    while(FI.get(ch)){
      if(ch=='<'){
	actFlag=1;
      }
      if(ch=='>'){
	if(actFlag==1){
	  if(actCount==1){
	    if((enterCount-1)!=nRow0*nCol0){
	      std::cout<<enterCount<<"!="<<nRow0<<"x"<<nCol0<<std::endl;
	      flag0=4;
	    }
	  }
	  actFlag=0;
	  actCount++;
	  strCount=0;
	  tabCount=0;
	  enterCount=0;
	}
	else{
	  std::cout<<"ERROR string > "<<std::endl;
	}
      }
      else{
	if(actFlag==1){
	  if(ch=='\t'){
	    *(s0+strCount)='\0';
	    tmp=atoi(s0);
	    *(SP+tabCount)=tmp;
	    strCount=0;
	    tabCount++;
	  }
	  else if(ch=='\n'){
	    if(enterCount>0){
	      *(s0+strCount)='\0';
	      tmp=atoi(s0);
	      *(SP+tabCount)=tmp;
	      tabCount++;
	      if(actCount==0){
		if(tabCount==9){
		  nRow0=*(SP+0);
		  nCol0=*(SP+1);
		  nBomb0=*(SP+3);
		  BombCount0=*(SP+5);
		  MissCount0=*(SP+6);
		  mode0=*(SP+8);
		}
		else{
		  std::cout<<"ERROR STATUS"<<std::endl;
		  flag0=4;
		}
	      }
	      else if(actCount==1){
		if(tabCount==5){
		  /*
		  std::cout<<"BOARD ["<<enterCount<<"]:";
		  std::cout<<"("<<*(SP+2)<<","<<*(SP+3)<<")";
		  */
		  sTmp=*(SP+2);
		  bTmp=*(SP+3);
		  if(sTmp==2){
		    if(bTmp>0){
		      //  std::cout<<"MATCH";
		      bFlag++;
		      matchFlag++;
		    }
		    else{
		      //  std::cout<<"MISS";
		      missFlag++;
		    }
		  }
		  else{
		    if(bTmp>0){
		      //  std::cout<<"BOMB";
		      bFlag++;
		    }
		    else{
		      //  std::cout<<"NONE";
		    }
		  }
		  //  std::cout<<std::endl;
		}
		else{
		  std::cout<<"ERROR BOARD "<<enterCount-1<<std::endl;
		  flag0=4;
		}
	      }
	      else if(actCount==2){
		if(tabCount==4){
		  inode=*(SP+0);
		  atime=*(SP+1);
		  mtime=*(SP+2);
		  ctime=*(SP+3);
		}
		else{
		  std::cout<<"ERROR FILE "<<std::endl;
		  flag0=4;
		}
	      }
	      else{
		std::cout<<"FEW COUNT"<<std::endl;
	      }
	    }
	    strCount=0;
	    tabCount=0;
	    enterCount++;
	  }
	  else{
	    *(s0+strCount)=ch;
	    strCount++;
	  }
	}
      }
    }
    
    FI.close();
    if(matchFlag==BombCount0){
      std::cout<<"MATCH BOMBCOUNT"<<std::endl;
    }
    else{
      std::cout<<"WRONG BOMBCOUNT :"<<BombCount0;
      std::cout<<"!="<<matchFlag<<std::endl;
      flag0=4;
    }
    if(missFlag==MissCount0){
      std::cout<<"MATCH MISSCOUNT"<<std::endl;
    }
    else{
      std::cout<<"WRONG MISSCOUNT :"<<MissCount0;
      std::cout<<"!="<<missFlag<<std::endl;
      flag0=4;
    }
    if(bFlag==nBomb0){
      std::cout<<"MATCH BOMB"<<std::endl;
    }
    else{
      std::cout<<"WRONG BOMB :"<<nBomb0;
      std::cout<<"!="<<bFlag<<std::endl;
      flag0=4;
    }
    if(mode0>0){
      std::cout<<"MODE :"<<mode0<<std::endl;
    }
    else{
      std::cout<<"UNKNOWN MODE"<<std::endl;
      flag0=4;
    }
    if(actCount==3){
      std::cout<<"MATCH ACT"<<std::endl;
    }
    else{
      std::cout<<"FEW ACT"<<std::endl;
      flag0=4;
    }
    if(flag0==0){
      flag0=SaveFile::ElementCheck(flag0,inode,atime,mtime,ctime);
    }
  }
  return flag0;
}
