#include "vbox.h"

MainVBox::MainVBox(MineWindow *window0,MineTimer *timer0){
  window=window0;
  vbox= new Gtk::Table(3,4,FALSE);
  button = new Gtk::Button("Reset");
  status = new MineStatus();
  timer=timer0;
  scoreFile= new ScoreFile();
  scoreFile->ReadFile();
  scoreFile->SortList();
  scoreFile->ViewList();
  saveFile=new SaveFile();
  table =new MineTable(window,timer,scoreFile);
  menu = new MineMenu();
}
MainVBox::~MainVBox(){
  scoreFile->ALLDeleteList();
  delete scoreFile;
  delete saveFile;
  delete vbox;
  delete button;
  delete status;
  delete table;
  delete menu;
}

void MainVBox::ButtonClicked(){
  std::cout << "button click\n";
  table->ReCreate(table->nRow,table->nCol,table->pBomb,table->nSize);
  status->Refresh();
}

void MainVBox::Create(){
  int flag=0;

  window->add(*vbox);

  flag=saveFile->FindState();
  if(flag==0){
    std::cout<<"FIND SAVE.data"<<std::endl;
    saveFile->LoadState(table);
    loadDialog= new LoadDialog(timer,0);
  }
  else if(flag==1){
    std::cout<<"CAN'T FIND SAVE.data"<<std::endl;
    table->CreateTable();
  }
  else if(flag==2){
    table->CreateTable();
    loadDialog= new LoadDialog(timer,1);
    remove("MINE_SAVE.data");
  }
  else if(flag==3){
    table->CreateTable();
    loadDialog= new LoadDialog(timer,2);
    remove("MINE_SAVE.data");
  }
  else{
    table->CreateTable();
    loadDialog= new LoadDialog(timer,3);
    remove("MINE_SAVE.data");
  }

  button->set_size_request(-1,30);
  vbox->attach(*(menu->Create(table,status,timer,scoreFile,saveFile)),
	       0,3,0,1,Gtk::FILL|Gtk::EXPAND,
	       Gtk::SHRINK,0,0);
  vbox->attach(*(timer->timeLabel),0,1,1,2,
	       Gtk::SHRINK,Gtk::SHRINK,0,0);
  vbox->attach(*button,1,3,1,2,
		Gtk::FILL|Gtk::EXPAND,Gtk::SHRINK,0,0);
  vbox->attach(*(table->Show()),0,3,2,3,
	       Gtk::EXPAND|Gtk::FILL,
	       Gtk::EXPAND|Gtk::FILL,
	       0,0);
  vbox->attach(*(status->Create(table)),
	       0,3,3,4,Gtk::FILL|Gtk::EXPAND,
	       Gtk::SHRINK,0,0);
  button->show();
  vbox->show();
  
    button->signal_clicked().connect
    (sigc::mem_fun(*this,&MainVBox::ButtonClicked));
}
